=== debian/changelog ===
ros-ardent-fastrtps (1.5.0-12xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 08 Feb 2018 19:01:56 -0000
